#include "core/Image.h"

#define STB_IMAGE_IMPLEMENTATION
#define STBI_ONLY_PNG
#define STBI_MALLOC(n) coreAllocate(n)
#define STBI_REALLOC(p, n) coreReallocate(p, n)
#define STBI_FREE(p) coreFree(p)
#include <core/Logger.h>
#include <core/Utility.h>
#include <errno.h>
#include <stb_image.h>
#include <string.h>

static void printError(const char* path) {
    LOG_ERROR("Cannot read image '%s': %s", path, strerror(errno));
}

bool initImage8(Image8* i, const char* path) {
    *i = (Image8){0};
    i->data = stbi_load(path, &i->width, &i->height, &i->channels, 0);
    if(i->data == nullptr) {
        printError(path);
        return true;
    }
    return false;
}

void destroyImage8(Image8* i) {
    stbi_image_free(i->data);
    *i = (Image8){0};
}

bool initImage16(Image16* i, const char* path) {
    *i = (Image16){0};
    i->data = stbi_load_16(path, &i->width, &i->height, &i->channels, 0);
    if(i->data == nullptr) {
        printError(path);
        return true;
    }
    return false;
}

void destroyImage16(Image16* i) {
    stbi_image_free(i->data);
    *i = (Image16){0};
}
